import unittest, sys
import io
import re
import unittest.mock

from tmc import points

from tmc.utils import load, get_out

main = load('src.main', 'main')

class MainTest(unittest.TestCase):
   
    @points('1-2')
    def test_answer(self):
        main()

        output = list(get_out().strip().split("\n"))
        if output[-1] == "":
            output.pop()

        checkQuery = ['PAN NYC CAS AMS HEL 283.7 kg']
        modelAnswerLength = len(checkQuery)
        
        self.assertFalse(len(output) > modelAnswerLength, "Too many route combinations. You only need to print the route with the minimum emmisions!")

        # # Check output format
        # # Start: 5 ports with 3 routes each, separated by a space
        # # End: with x.x kg
        r = re.compile('^((\w{3} ){5})(\d+.\d kg)$') 
        isFormatCorrect = all(r.match(line) for line in output)
        self.assertTrue(isFormatCorrect, "The output format is incorrect. Please take a look at the example output.")
        
        # Default Test
        # Check if output and checkQuery contain the same elements irrespective of order
        self.assertTrue(sorted(output) == sorted(checkQuery), "Your answer is incorrect.")

        # self.assertEqual(output, 'PAN NYC CAS AMS HEL 283.7 kg')

if __name__ == '__main__':
    unittest.main()
